/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package metier;

import java.util.Objects;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import static javax.swing.JOptionPane.DEFAULT_OPTION;
import static javax.swing.JOptionPane.QUESTION_MESSAGE;

/**
 *
 * @author Dominique_2
 */
public class Voleur extends Personnage{
    
    private String outil;
    private String [] outils={"Pierre","Feuille","Ciseaux"};

    public Voleur(String nom, String img, int energie, int dureeVie, String outil) {
        super(nom, img, energie, dureeVie);
        this.outil = outil;
        //this.butin = butin;
    }

    @Override
    public int hashCode() {
        int hash = 7;
        hash = super.hashCode() + (29 * hash + Objects.hashCode(this.outil));
        return hash;
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final Voleur other = (Voleur) obj;
        if (!Objects.equals(this.outil, other.outil)) {
            return false;
        }
        if (!super.equals(obj)) {
            return false;
        }        
        return true;
    }

    @Override
    public String toString() {
        return super.toString() + "\t Outil=" + outil + "\nButin=";
    }

    /**
     * Get the value of outil
     *
     * @return the value of outil
     */
    public String getOutil() {
        return outil;
    }

    /**
     * Set the value of outil
     *
     * @param outil new value of outil
     */
    public void setOutil(String outil) {
        this.outil = outil;
    }

    public String[] getOutils() {
        return outils;
    }

    public void setOutils(String[] outils) {
        this.outils = outils;
    }
    
    private int jeuPFC(String J1, String J2) {
        if (J1 == "Pierre" && J2 == "Feuille") {
            return -1;
        } else if (J1 == "Feuille" && J2 == "Pierre") {
            return 1;
        } else if (J1 == "Feuille" && J2 == "Ciseaux") {
            return -1;
        } else if (J1 == "Ciseaux" && J2 == "Feuille") {
            return 1;
        } else if (J1 == "Ciseaux" && J2 == "Pierre") {
            return -1;
        } else if (J1 == "Pierre" && J2 == "Ciseaux") {
            return 1;
        } else {
            return 0;
        }
    }
    
    /**
     * Rsume les informations sur le personnage
     * @return Informations du personnage
     */
    @Override
    public String resumerPersonnage() {
        String str = "";
        str  += "Nom    "+this.getNom()+"\n";
        str  += "nergie    "+this.getEnergie()+"\n";
        str  += "Dure de vie    "+this.getDureeVie()+"\n";
        str  += "Voleur    arme : "+this.getOutil()+"\n";
        
        return str;
    }
    
    /**
     * Initie la rencontre avec un autre personnage
     * @param unPerso un Personnage
     * @return Message de rencontre
     */
    public String rencontrer(Personnage unPerso) {
        // Message de défi à l'adversaire
        String titre = this.getNom() + " rencontre " + unPerso.getNom() + " : Pierre Feuille Ciseaux";
        String message = "Es-tu prêt à me combattre "+ unPerso.getNom() +" ?";
        
        // Icone de PFC à afficher
        Icon iPFC = new javax.swing.ImageIcon(getClass().getResource("/img/pierreFeuilleCiseaux.jpg"));
        
        // Envoi du message et de l'icone dans une boite de dialogue
        JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE, iPFC);
        
        // Message de choix du PFC
        message = "Que choisis-tu, "+ unPerso.getNom() +" ?";
        
        // Choix du joueur avec des boutons
        int reponse = JOptionPane.showOptionDialog(null, message, titre, DEFAULT_OPTION, QUESTION_MESSAGE, iPFC, outils, 0);
        
        // Choix aléatoire du Voleur
        int choixVoleur = Jeu.genererNbAleatoire(0, 2);
        
        // Comparaison des choix pour définir un vainqueur
        int PFC = this.jeuPFC(this.outils[choixVoleur], this.outils[reponse]);
        message = "Mon choix: "+ this.outils[choixVoleur] +" - Ton choix: "+ this.outils[reponse] +"\n\n";
        
        // Prendra en valeur l'image du vainqueur si vainqueur, il y a
        Icon ImgVainqueur;
        
        if (PFC > 0) { // Si this Voleur gagne
            // Message de victoire
            message += this.getNom() +" l'emporte !\n\n";
            ImgVainqueur = new javax.swing.ImageIcon(getClass().getResource("/img/"+ this.getNom() +".jpg"));
            
            // Ajout d'un point d'énergie au Voleur
            this.setEnergie(this.getEnergie()+1);
            
            // Retrait d'un point d'énergie à l'autre combattant
            unPerso.setEnergie(unPerso.getEnergie()-1);
            
            // Retrait d'un point de vie à l'autre combattant
            unPerso.setDureeVie(unPerso.getDureeVie()-1);
        } else if (PFC < 0) { // Si l'autre combattant gagne
            // Message de victoire
            message += unPerso.getNom() +" l'emporte !\n\n";
            ImgVainqueur = new javax.swing.ImageIcon(getClass().getResource("/img/"+ unPerso.getNom() +".jpg"));
            
            // Retrait d'un point d'énergie au Voleur
            this.setEnergie(this.getEnergie()-1);
            
            // Ajout d'un point d'énergie à l'autre combattant
            unPerso.setEnergie(unPerso.getEnergie()+1);
        } else {
            ImgVainqueur = null;
            // Message d'égalité
            message += "Il y a égalité entre les parties !\n\n";
        }
        
        // Message d'information sur les vies de chaque partie
        message += this.getNom() +": "+ this.getDureeVie()+" - "+ unPerso.getNom() +": "+ unPerso.getDureeVie();
        
        // Envoi du message et de l'icone dans une boîte du dialogue
        JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE, ImgVainqueur);
        return message;
    }
    
    /**
      * Saluer un personnage
      * @param unPerso Un personnage
      * @return Message de salutation
    */
    @Override
    public String saluer(Personnage unPerso) {
        String titre = this.getNom() + " salue " + unPerso.getNom();
        String message = "Bonjour " + unPerso.getNom() + ", si tu baisses ton attention, je vais te dépouiller !";
        //JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE);
        Icon imgPerso = new javax.swing.ImageIcon(getClass().getResource("/img/" + this.getImg()));
        JOptionPane.showMessageDialog(null, message, titre, JOptionPane.INFORMATION_MESSAGE, imgPerso);       
        return message;
    }
}
